using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Windows.Forms;

namespace PrintingDemoCS
{
	public class frmAdvanced : PrintingDemoCS.frmBasic
	{
		private System.ComponentModel.IContainer components = null;

		public frmAdvanced()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmAdvanced());
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.SuspendLayout();
			// 
			// pageSetupButton
			// 
			this.pageSetupButton.Visible = true;
			// 
			// btnPrintPreview
			// 
			this.btnPrintPreview.Visible = true;
			// 
			// btnPrint
			// 
			this.btnPrint.Visible = true;
			// 
			// label1
			// 
			this.label1.Size = new System.Drawing.Size(176, 32);
			this.label1.Text = "Advanced Printing";
			this.label1.Visible = true;
			// 
			// frmAdvanced
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.pageSetupButton,
																		  this.btnPrintPreview,
																		  this.btnPrint});
			this.Name = "frmAdvanced";
			this.Text = "Printing with Inheritance";
			this.ResumeLayout(false);

		}
		#endregion

		#region btnPrint_Click
		protected override void btnPrint_Click(object sender, System.EventArgs e)
		{
			try
			{
				dlgOpen.InitialDirectory = Application.ExecutablePath;
				if (dlgOpen.ShowDialog() == DialogResult.OK)
				{
					streamToPrint = new StreamReader(dlgOpen.OpenFile());
					TextFilePrintDocument printDoc = new TextFilePrintDocument(streamToPrint);
					try
					{
						if (storedPageSettings != null)  
							printDoc.DefaultPageSettings = storedPageSettings;
	                    
						printDoc.Print();
					}
					finally
					{
						streamToPrint.Close();
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("An error occurred printing the file - " + ex.Message) ;
			}		
		}
		#endregion

		#region btnPrintPreview_Click
		protected override void btnPrintPreview_Click(object sender, System.EventArgs e)
		{
			try
			{
				dlgOpen.InitialDirectory = Application.ExecutablePath;
				if (dlgOpen.ShowDialog() == DialogResult.OK)
				{
					streamToPrint = new StreamReader(dlgOpen.OpenFile());
					TextFilePrintDocument printDoc = new TextFilePrintDocument(streamToPrint);
					try
					{
						if (storedPageSettings != null)
							printDoc.DefaultPageSettings = storedPageSettings;

						dlgPrintPreview.Document = printDoc;
						dlgPrintPreview.ShowDialog();
					}
					finally
					{
						streamToPrint.Close();									
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("An error occurred printing the file - " + ex.Message);
			}		
		}		
		#endregion
	}
}

