using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Printing;
using System.IO;

namespace PrintingDemoCS
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmBasic : System.Windows.Forms.Form
	{
		protected Font printFont = new Font("Comic Sans MS", 12);
		protected StreamReader streamToPrint = null; 
		protected PageSettings storedPageSettings = null;

		protected Button pageSetupButton;
		protected Button btnPrintPreview;
		protected Button btnPrint;

		internal OpenFileDialog dlgOpen;
		internal PrintDocument printDoc;
		internal PageSetupDialog dlgPageSetup;
		internal PrintPreviewDialog dlgPrintPreview;
		protected System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmBasic()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmBasic));
			this.pageSetupButton = new System.Windows.Forms.Button();
			this.btnPrintPreview = new System.Windows.Forms.Button();
			this.btnPrint = new System.Windows.Forms.Button();
			this.dlgOpen = new System.Windows.Forms.OpenFileDialog();
			this.printDoc = new System.Drawing.Printing.PrintDocument();
			this.dlgPageSetup = new System.Windows.Forms.PageSetupDialog();
			this.dlgPrintPreview = new System.Windows.Forms.PrintPreviewDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// pageSetupButton
			// 
			this.pageSetupButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.pageSetupButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.pageSetupButton.Location = new System.Drawing.Point(32, 112);
			this.pageSetupButton.Name = "pageSetupButton";
			this.pageSetupButton.Size = new System.Drawing.Size(136, 40);
			this.pageSetupButton.TabIndex = 6;
			this.pageSetupButton.Text = "Page Settings";
			this.pageSetupButton.Click += new System.EventHandler(this.pageSetupButton_Click);
			// 
			// btnPrintPreview
			// 
			this.btnPrintPreview.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnPrintPreview.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnPrintPreview.Location = new System.Drawing.Point(32, 168);
			this.btnPrintPreview.Name = "btnPrintPreview";
			this.btnPrintPreview.Size = new System.Drawing.Size(136, 40);
			this.btnPrintPreview.TabIndex = 7;
			this.btnPrintPreview.Text = "Print Preview";
			this.btnPrintPreview.Click += new System.EventHandler(this.btnPrintPreview_Click);
			// 
			// btnPrint
			// 
			this.btnPrint.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.btnPrint.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnPrint.Location = new System.Drawing.Point(32, 56);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.Size = new System.Drawing.Size(136, 40);
			this.btnPrint.TabIndex = 5;
			this.btnPrint.Text = "Print the file";
			this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
			// 
			// dlgOpen
			// 
			this.dlgOpen.DefaultExt = "*.txt";
			this.dlgOpen.Title = "Select a file to Print";
			// 
			// printDoc
			// 
			this.printDoc.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDoc_PrintPage);
			// 
			// dlgPrintPreview
			// 
			this.dlgPrintPreview.AutoScrollMargin = new System.Drawing.Size(0, 0);
			this.dlgPrintPreview.AutoScrollMinSize = new System.Drawing.Size(0, 0);
			this.dlgPrintPreview.ClientSize = new System.Drawing.Size(400, 300);
			this.dlgPrintPreview.Enabled = true;
			this.dlgPrintPreview.Icon = ((System.Drawing.Icon)(resources.GetObject("dlgPrintPreview.Icon")));
			this.dlgPrintPreview.Location = new System.Drawing.Point(203, 17);
			this.dlgPrintPreview.MaximumSize = new System.Drawing.Size(0, 0);
			this.dlgPrintPreview.Name = "dlgPrintPreview";
			this.dlgPrintPreview.Opacity = 1;
			this.dlgPrintPreview.TransparencyKey = System.Drawing.Color.Empty;
			this.dlgPrintPreview.Visible = false;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Comic Sans MS", 14.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(32, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(152, 32);
			this.label1.TabIndex = 8;
			this.label1.Text = "Basic Printing";
			// 
			// frmBasic
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.pageSetupButton,
																		  this.btnPrintPreview,
																		  this.btnPrint});
			this.Name = "frmBasic";
			this.Text = "Printing with PrintDocument";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmBasic());
		}

		#region btnPrint_Click
		protected virtual void btnPrint_Click(object sender, System.EventArgs e)
		{
			try
			{
				dlgOpen.InitialDirectory = Application.ExecutablePath;
				if (dlgOpen.ShowDialog() == DialogResult.OK)
				{
					streamToPrint = new StreamReader(dlgOpen.OpenFile());
					try
					{
						if (storedPageSettings != null)  
							printDoc.DefaultPageSettings = storedPageSettings;
	                    
						printDoc.Print();
					}
					finally
					{
						streamToPrint.Close();
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("An error occurred printing the file - " + ex.Message) ;
			}		
		}
		#endregion

		#region printDoc_PrintPage
		protected virtual void printDoc_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			float lpp = 0;
			float yPos = 0;
			int count = 0;
			float leftMargin = e.MarginBounds.Left;
			float topMargin = e.MarginBounds.Top;
			string line = string.Empty;

			//Work out the number of lines per page
			//Use the MarginBounds on the event to do this
			lpp = e.MarginBounds.Height / printFont.GetHeight(e.Graphics);

			//Now iterate over the file printing out each line
			//NOTE WELL: This assumes that a single line is not wider than the page width
			//Check count first so that we don't read line that we won't print
			line = streamToPrint.ReadLine();

			while (count < lpp && streamToPrint.Peek() > -1)
			{
				yPos = topMargin + (count * printFont.GetHeight(e.Graphics));

				e.Graphics.DrawString(line, printFont, Brushes.Black, leftMargin, yPos, new StringFormat());

				count++;

				if (count < lpp) line = streamToPrint.ReadLine();
			}

			//If we have more lines then print another page
			e.HasMorePages = (streamToPrint.Peek() > -1) ;
		}
		#endregion

		#region pageSetupButton_Click
		private void pageSetupButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				if (storedPageSettings == null) 
					storedPageSettings = new PageSettings();
            
				dlgPageSetup.PageSettings = storedPageSettings;
				dlgPageSetup.ShowDialog();
			}
			catch(Exception ex)
			{
				MessageBox.Show("An error occurred - " + ex.Message);
			}		
		}
		#endregion

		#region btnPrintPreview_Click
		protected virtual void btnPrintPreview_Click(object sender, System.EventArgs e)
		{
			try
			{
				dlgOpen.InitialDirectory = Application.ExecutablePath;
				if (dlgOpen.ShowDialog() == DialogResult.OK)
				{
					streamToPrint = new StreamReader(dlgOpen.OpenFile());

					try
					{
						if (storedPageSettings != null)
							printDoc.DefaultPageSettings = storedPageSettings;

						dlgPrintPreview.Document = printDoc;
						dlgPrintPreview.ShowDialog();
					}
					finally
					{
						streamToPrint.Close();									
					}
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("An error occurred printing the file - " + ex.Message);
			}
        }
		#endregion
	}
}
