Imports System.IO
Imports System.Drawing.Printing

Public Class frmBasic
    Inherits System.Windows.Forms.Form

    Friend WithEvents dlgOpen As System.Windows.Forms.OpenFileDialog
    Friend WithEvents dlgPageSetup As System.Windows.Forms.PageSetupDialog
    Friend WithEvents dlgPrintPreview As System.Windows.Forms.PrintPreviewDialog
    Friend WithEvents printDoc As System.Drawing.Printing.PrintDocument

    Protected WithEvents btnPrint As System.Windows.Forms.Button
    Protected WithEvents pageSetupButton As System.Windows.Forms.Button
    Protected WithEvents printPreviewButton As System.Windows.Forms.Button
    Protected printFont As Font = New Font("Arial", 16)
    Protected streamToPrint As StreamReader
    Protected storedPageSettings As PageSettings

#Region " Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.  
    Protected WithEvents Label1 As System.Windows.Forms.Label

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmBasic))
        Me.btnPrint = New System.Windows.Forms.Button()
        Me.pageSetupButton = New System.Windows.Forms.Button()
        Me.printPreviewButton = New System.Windows.Forms.Button()
        Me.dlgOpen = New System.Windows.Forms.OpenFileDialog()
        Me.printDoc = New System.Drawing.Printing.PrintDocument()
        Me.dlgPageSetup = New System.Windows.Forms.PageSetupDialog()
        Me.dlgPrintPreview = New System.Windows.Forms.PrintPreviewDialog()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'btnPrint
        '
        Me.btnPrint.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btnPrint.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.btnPrint.Location = New System.Drawing.Point(32, 56)
        Me.btnPrint.Name = "btnPrint"
        Me.btnPrint.Size = New System.Drawing.Size(136, 40)
        Me.btnPrint.TabIndex = 0
        Me.btnPrint.Text = "Print the file"
        '
        'pageSetupButton
        '
        Me.pageSetupButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.pageSetupButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.pageSetupButton.Location = New System.Drawing.Point(32, 112)
        Me.pageSetupButton.Name = "pageSetupButton"
        Me.pageSetupButton.Size = New System.Drawing.Size(136, 40)
        Me.pageSetupButton.TabIndex = 3
        Me.pageSetupButton.Text = "Page Settings"
        '
        'printPreviewButton
        '
        Me.printPreviewButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.printPreviewButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.printPreviewButton.Location = New System.Drawing.Point(32, 168)
        Me.printPreviewButton.Name = "printPreviewButton"
        Me.printPreviewButton.Size = New System.Drawing.Size(136, 40)
        Me.printPreviewButton.TabIndex = 4
        Me.printPreviewButton.Text = "Print Preview"
        '
        'dlgOpen
        '
        Me.dlgOpen.DefaultExt = "*.txt"
        Me.dlgOpen.Title = "Select a file to Print"
        '
        'printDoc
        '
        '
        'dlgPrintPreview
        '
        Me.dlgPrintPreview.AutoScrollMargin = New System.Drawing.Size(0, 0)
        Me.dlgPrintPreview.AutoScrollMinSize = New System.Drawing.Size(0, 0)
        Me.dlgPrintPreview.ClientSize = New System.Drawing.Size(400, 300)
        Me.dlgPrintPreview.Enabled = True
        Me.dlgPrintPreview.Icon = CType(resources.GetObject("dlgPrintPreview.Icon"), System.Drawing.Icon)
        Me.dlgPrintPreview.Location = New System.Drawing.Point(322, 0)
        Me.dlgPrintPreview.MaximumSize = New System.Drawing.Size(0, 0)
        Me.dlgPrintPreview.Name = "dlgPrintPreview"
        Me.dlgPrintPreview.Opacity = 1
        Me.dlgPrintPreview.TransparencyKey = System.Drawing.Color.Empty
        Me.dlgPrintPreview.Visible = False
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Comic Sans MS", 14.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(40, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(144, 32)
        Me.Label1.TabIndex = 5
        Me.Label1.Text = "Basic Printing"
        '
        'frmBasic
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(320, 266)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label1, Me.pageSetupButton, Me.printPreviewButton, Me.btnPrint})
        Me.Name = "frmBasic"
        Me.Text = "Printing with PrintDocument"
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "btnPrint_Click"
    Protected Overridable Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        Try
            dlgOpen.InitialDirectory = Application.ExecutablePath
            If dlgOpen.ShowDialog() = DialogResult.OK Then
                streamToPrint = New StreamReader(dlgOpen.OpenFile())
                Try
                    If Not (storedPageSettings Is Nothing) Then
                        printDoc.DefaultPageSettings = storedPageSettings
                    End If
                    printDoc.Print()
                Finally
                    streamToPrint.Close()
                End Try
            End If
        Catch ex As Exception
            MessageBox.Show("An error occurred printing the file - " & ex.Message)
        End Try
    End Sub
#End Region

#Region "Page Setup"
    Protected Overridable Sub pageSetupButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pageSetupButton.Click
        Try
            If (storedPageSettings Is Nothing) Then
                storedPageSettings = New PageSettings()
            End If

            dlgPageSetup.PageSettings = storedPageSettings
            dlgPageSetup.ShowDialog()
        Catch ex As Exception
            MessageBox.Show("An error occurred - " & ex.Message)
        End Try
    End Sub
#End Region

#Region "Print Preview"
    Protected Overridable Sub printPreviewButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles printPreviewButton.Click
        Try
            dlgOpen.InitialDirectory = Application.ExecutablePath
            If dlgOpen.ShowDialog() = DialogResult.OK Then
                streamToPrint = New StreamReader(dlgOpen.OpenFile())

                Try
                    If Not (storedPageSettings Is Nothing) Then
                        printDoc.DefaultPageSettings = storedPageSettings
                    End If

                    dlgPrintPreview.Document = printDoc
                    dlgPrintPreview.ShowDialog()
                Finally
                    streamToPrint.Close()
                End Try
            End If

        Catch ex As Exception
            MessageBox.Show("An error occurred printing the file - " & ex.Message)
        End Try
    End Sub
#End Region

#Region "printDoc_PrintPage"
    Private Sub printDoc_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDoc.PrintPage
        Dim lpp As Single = 0
        Dim yPos As Single = 0
        Dim count As Integer = 0
        Dim leftMargin As Single = e.MarginBounds.Left
        Dim topMargin As Single = e.MarginBounds.Top
        Dim line As String

        'Work out the number of lines per page
        'Use the MarginBounds on the event to do this
        lpp = e.MarginBounds.Height / printFont.GetHeight(e.Graphics)

        'Now iterate over the file printing out each line
        'NOTE WELL: This assumes that a single line is not wider than the page width
        'Check count first so that we don't read line that we won't print
        line = streamToPrint.ReadLine()

        While (count < lpp And streamToPrint.Peek() > -1)

            yPos = topMargin + (count * printFont.GetHeight(e.Graphics))

            e.Graphics.DrawString(line, printFont, Brushes.Black, leftMargin, yPos, New StringFormat())

            count += 1

            If (count < lpp) Then
                line = streamToPrint.ReadLine()
            End If

        End While

        'If we have more lines then print another page
        If (streamToPrint.Peek() > -1) Then
            e.HasMorePages = True
        Else
            e.HasMorePages = False
        End If

    End Sub
#End Region
End Class
