using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace SortableListView
{
	/// <summary>
	/// Summary description for SortableListView.
	/// </summary>
	public class SortableListViewold : System.Windows.Forms.ListView 
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;			
		private int sortColumn = -1;

		public SortableListViewold()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitForm call
			this.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.Base_ColumnClick);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{			
			this.Name = "SortableListView";
		}
		#endregion

		#region ListViewItemComparer
		class ListViewItemComparer : IComparer 
		{
			private int col;
			private SortOrder order;
			public ListViewItemComparer() 
			{
				col=0;
				order = SortOrder.Ascending;
			}
			public ListViewItemComparer(int column, SortOrder order) 
			{
				col=column;
				this.order = order;
			}
			public int Compare(object x, object y) 
			{
				int returnVal= -1;
				returnVal = String.Compare(((ListViewItem)x).SubItems[col].Text,
					((ListViewItem)y).SubItems[col].Text);
				// Determine whether the sort order is descending.
				if(order == SortOrder.Descending)
					// Invert the value returned by String.Compare.
					returnVal *= -1;
				return returnVal;
			}
		}
		#endregion

		private void Base_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
			// Determine whether the column is the same as the last column clicked.
			if (e.Column != sortColumn)
			{
				// Set the sort column to the new column.
				sortColumn = e.Column;
				// Set the sort order to ascending by default.
				this.Sorting = SortOrder.Ascending;
			}
			else
			{
				// Determine what the last sort order was and change it.
				if (this.Sorting == SortOrder.Ascending)
					this.Sorting = SortOrder.Descending;
				else
					this.Sorting = SortOrder.Ascending;
			}

			// Call the sort method to manually sort.
			this.Sort();
			// Set the ListViewItemSorter property to a new ListViewItemComparer
			// object.
			this.ListViewItemSorter = new ListViewItemComparer(e.Column, this.Sorting);
		}
	}
}
