Imports System.Windows.Forms

Public Class SortableListViewVB
    Inherits System.Windows.Forms.ListView

#Region " Windows Form Designer generated code "
    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
    End Sub

#End Region

    Private sortColumn As Integer = -1

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        AddHandler Me.ColumnClick, AddressOf Me.Base_ColumnClick

        Me.View = View.Details
        Me.GridLines = True
        Me.FullRowSelect = True
    End Sub

    Public Sub AddItems(ByVal ParamArray stringArray As String())
        Me.Items.Add(New ListViewItem(stringArray))
    End Sub

#Region "Base_ColumnClick"
    Public Sub Base_ColumnClick(ByVal sender As Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs)
        If e.Column <> Me.sortColumn Then
            Me.sortColumn = e.Column
            Me.Sorting = SortOrder.Ascending
        Else
            If Me.Sorting = SortOrder.Ascending Then
                Me.Sorting = SortOrder.Descending
            Else
                Me.Sorting = SortOrder.Ascending
            End If
        End If

        Me.ListViewItemSorter = New SortableListViewVB.ListViewItemComparer(Me.sortColumn, Me.Sorting)
        Me.Sort()
    End Sub
#End Region

#Region "ListViewItemComparer"
    Private Class ListViewItemComparer
        Implements IComparer

        Private col As Integer
        Private order As SortOrder

        Public Sub New()
            col = 0
            order = SortOrder.Ascending
        End Sub

        Public Sub New(ByVal column As Integer, ByVal order As SortOrder)
            col = column
            Me.order = order
        End Sub

        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare

            Dim returnVal As Integer = 0
            Dim firstItem As String = CType(x, ListViewItem).SubItems(col).Text.Trim
            Dim secondItem As String = CType(y, ListViewItem).SubItems(col).Text.Trim

            Try
                Dim firstDate As DateTime = DateTime.Parse(firstItem)
                Dim secondDate As DateTime = DateTime.Parse(secondItem)
                returnVal = DateTime.Compare(firstDate, secondDate)
            Catch
                Try
                    Dim firstInteger As Integer = Integer.Parse(firstItem)
                    Dim secondInteger As Integer = Integer.Parse(secondItem)
                    If firstInteger < secondInteger Then
                        returnVal = -1
                    End If
                    If firstInteger = secondInteger Then
                        returnVal = 0
                    End If
                    If firstInteger > secondInteger Then
                        returnVal = 1
                    End If
                Catch
                    returnVal = String.Compare(firstItem, secondItem)
                End Try
            End Try

            If order = SortOrder.Descending Then
                returnVal *= -1
            End If

            Return returnVal

        End Function
    End Class
#End Region
End Class

